/************************************************************************
Invariant keypoint matching.
Based on demo software by D. Lowe.
Author: David Lowe, V. Ferrari, A. Thomas

Modified by Ferrari and A. Thomas
                     
match.c:
This file contains a program to read keypoints, and output matches as
  coordinates and/or indices.
*************************************************************************/

#ifndef MATCH_SIFT_H
#define MATCH_SIFT_H


/* Data structure for a keypoint.  Lists of keypoints are linked
   by the "next" field.
*/
typedef struct KeypointSt {
  int index;
  float row, col;             /* Subpixel location of keypoint. */
  float scale, ori;           /* Scale and orientation (range [-PI,PI]) */
  unsigned char *descrip;     /* Vector of 128 descriptor values */
  struct KeypointSt *next;    /* Pointer to next keypoint in list. */
} *Keypoint;


/* -------------------- Local function prototypes ------------------------ */

void FatalError(const char *fmt, ...);
Keypoint ReadKeyFileVIBES(char* filename);
Keypoint ReadKeysVIBES(FILE *fp);
int FindSoftMatches(Keypoint keys1, Keypoint keys2, char *matchesfile, char *idfile);
int FindSoft3Matches(Keypoint keys1, Keypoint keys2, char *matchesfile, char *idfile);
unsigned int DistSquared(Keypoint k1, Keypoint k2);


#endif
