

#include <misc_utility/count_pixels.h>


// Amount of pixels of color 'col' in image 'buf'
int count_pixels(vil1_rgb<unsigned char>& col, color_buffer_t* buf)
{
  int n = 0;
  for(int x = 0; x < buf->width(); x++) {
    for(int y = 0; y < buf->height(); y++) {
      vil1_rgb<unsigned char> pixel = (*buf)(x, y);
      if(col == pixel) {
	n++;
      }      
    }
  }

  return n;
} // count_pixels



vil1_rgb<unsigned char> border_color(color_buffer_t* buf) {
   long int r = 0;
   long int g = 0;
   long int b = 0;
   int n = 0;            // amount of border pixels
  
   // loop over all buf pixels
   for(int x = 0; x < buf->width()-1; x++) {
	for(int y = 0; y < buf->height()-1; y++) {
              // if (x,y) on border
              if(x < 5 || x > buf->width()-5 || y < 5 || y > buf->height()-5) {
                 vil1_rgb<unsigned char> pixel = (*buf)(x, y);
	         r += pixel.R();  g += pixel.G();   b += pixel.B();
                 n++;
              } // (x,y) on border
 	}
   }

   vil1_rgb<unsigned char> bcol((int)(r/n), (int)(g/n), (int)(b/n));
   return bcol;
}
