#ifndef _defines_h
#define _defines_h

#include <vcl/vcl_vector.h>
#include <vcl/vcl_list.h>
#include <vcl/vcl_utility.h>
#include <vgl/vgl_homg_point_2d.h>
#include <vil1/vil1_memory_image_of.h>
#include <vil1/vil1_rgb_byte.h>


enum {
	RET_SUCCESS,
	RET_ERROR,
	RET_EXEC_FAIL,
	RET_WRONG_ARG
};


class region;
class vdgl_digital_curve;
class uniform_region;

typedef vil1_memory_image_of<vil1_rgb_byte> color_buffer_t;
typedef vil1_memory_image_of<unsigned char> bw_buffer_t;

typedef double type_t;
typedef vgl_homg_point_2d<type_t> point_t;

typedef vcl_vector<region*> regions_list_t;
typedef vcl_vector<point_t*> points_list_t;
typedef vcl_vector<vdgl_digital_curve*> curves_list_t;
typedef vcl_vector<uniform_region*> uniform_regions_list_t;

// typedef vcl_pair<region*, region*> region_match_t;
// typedef vcl_pair<int, int> index_match_t;
// typedef vcl_list<region_match_t > rmatches_list_t;
// typedef vcl_list<index_match_t > imatches_list_t;
// typedef vcl_list<region* > region_cluster_t;
// typedef vcl_list<int > index_cluster_t;


#define MINTWO(a, b)  (( (a) < (b) ) ? (a) : (b))
#define MINTHREE(a, b, c)  ((((a)<(b)?(a):(b)))<(c)?(((a)<(b)?(a):(b))):(c))
#define MINFOUR(a, b, c, d)  (MINTWO( MINTWO((a), (b)), MINTWO((c), (d)) ))

#define MAXTWO(a, b)  (( (a) > (b) ) ? (a) : (b))
#define MAXTHREE(a, b, c) ((((a)>(b)?(a):(b)))>(c)?(((a)>(b)?(a):(b))):(c)) 
#define MAXFOUR(a, b, c, d)  (MAXTWO( MAXTWO((a), (b)), MAXTWO((c), (d)) ))

// conflicts with math.h!!!
//#define round(x) ( (int) ((double)x+0.5) )

#endif // _defines_h
