#ifndef __loaders_h
#define __loaders_h


#include <vcl/vcl_vector.h>
#include <mvl/HomgPoint2D.h>
#include <misc_utility/defines.h>
#include <regions/uniform_region.h>

vcl_vector<HomgPoint2D> load_points(const char* filename);
void save_bools(vcl_vector<bool>& vals, const char* filename);
void save_ints(vcl_vector<int>& vals, const char* filename);
void save_floats(vcl_vector<float>& vals, const char* filename);
void save_floats(vcl_vector<float>** vals, const int size1, const char* filename);
void save_uniform_regions(uniform_regions_list_t* urs, const char* filename);
uniform_regions_list_t* load_uniform_regions(const char* filename);
bool end_of_line(vcl_ifstream& regfile);
vcl_vector<float>* load_floats(const char* filename);
bool is_digit(vcl_ifstream& regfile);
void skip_to_eol(vcl_ifstream& regfile);

#endif
