//////////////////////////////////////////////////////////////////////
//
// ParallregionExtractor.h: interface for the ParallregionFinder class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _PARALLREGIONEXTRACTOR_
#define _PARALLREGIONEXTRACTOR_

#include <misc_utility/defines.h>
#include <regions/parall_region.h>
#include <region_extraction/region_extractor.h>
#include <vdgl/vdgl_digital_curve.h>



class parall_region_extractor : public region_extractor  
{
public:
  parall_region_extractor(reg_ext_starter *starter);
  virtual ~parall_region_extractor();

  virtual bool extract_regions(point_t* pt, 
                              region::region_specific_type tp = region::REGION_NO_SPECIFIC_TYPE) = 0;
  virtual bool extract_all_regions() = 0;


protected:
  bool compute_lines(point_t* Corner);	//  This function takes the lines and determines 
  // if they are good for _Lines1  and _Lines2
  bool intersect_lines(vdgl_digital_curve *l1, vdgl_digital_curve *l2, point_t *pt);
  bool split_edgelchain_from_point(vdgl_digital_curve *l2, vdgl_digital_curve*& l21, vdgl_digital_curve*& l22, 
                                point_t *pt);

  bool split_color_bands(const vil1_memory_image_of<vil1_rgb_byte>& buf, vil1_memory_image_of<byte>& R_buf, 
                       vil1_memory_image_of<byte>& G_buf, vil1_memory_image_of<byte>& B_buf);

  bool maximum_region(const point_t &ctr, vdgl_digital_curve& l1, vdgl_digital_curve& l2, 
                     point_t*& p1, point_t*& p2);

  //  Here we put the protected members
  bool _offset_invariants, _ColorImage;
  //bool _verbose;
  curves_list_t *_Lines1, *_Lines2;
  points_list_t *_centers;
  point_t *p1, *p2;
	

private:
  //  Here we keep the private members
	

};

#endif // !defined _PARALLREGIONEXTRACTOR_
