#include "reg_ext_params.h"


// --------------------------------------------------
// Setting values in constructor
// --------------------------------------------------
reg_ext_params::reg_ext_params()
{
  // Region extraction related parameters
  max_size   = 100;          // Maximum region size (used by curved reg extr)
  min_size   = 10;          // Minimum region size
  max_dist   = 10;          // Max. distance to look for intersections (never used ??)
  min_length = 10;          // Minimum length of edge to be retained
	
	
  // Canny parameters
  sigma_CannyOX              = 1.0;
  max_width_CannyOX          = 12;
  gauss_tail_CannyOX         = 0.015;
  low_CannyOX                = 6.0;
  high_CannyOX               = 12.0;
  follow_strategy_CannyOX    = 2;
  edge_min_CannyOX           = 10;     
  min_length_CannyOX         = 15;  
  border_size_CannyOX        = 2;
  border_value_CannyOX       = 0.0;
  scale_CannyOX              = 1.0;
  join_flag_CannyOX          = true;
  junction_option_CannyOX    = false;
	
  // Line fitting parameters
  min_fit_length_FitLines    = 15; 
  threshold_FitLines         = 0.3;
  theta_FitLines             = 5.0;
	
  // Harris parameters  I don't think that anything needs to be done with these
  //					  as they are already set to the defaults.
  //params_Harris;  
	
  // Intensity extrema parameters
  size_IntExtrema    = 21;
  //sigma_IntExtrema   = 3.0; // (not used - hardcoded sigma for time being)
	
  // Elliptical region extraction parameters
  min_size_EllRegExt       = 5;
  max_size_EllRegExt       = 40;
  number_of_rays_EllRegExt = 40;
  resize_factor_EllRegExt  = 2.0; // double region size by default

  // Parall region extraction parameters
  MinSideLength = 10;      // default = 5, just to try to reduce noise
  MaxSideLength = 100;
  MaxDistanceFromPointToEdge = 10.0;
}




reg_ext_params::~reg_ext_params()
{
}
