#ifndef _VIBES_matchesfile_h
#define _VIBES_matchesfile_h

#include <vcl/vcl_strstream.h>
#include <vcl/vcl_iostream.h>
#include <vcl/vcl_fstream.h>
#include <vcl/vcl_list.h>

#include <misc_utility/defines.h>
#include <region_matching/matches.h>

// A class containing some basic functions to read / write
// regions to a file

class region;
class vil1_image;

class VIBES_matches_file : public matches_file
{
public:
  VIBES_matches_file(bool verbose = false);
  virtual ~VIBES_matches_file();
  
  virtual bool save_matches(matches& mtches, 
			    const char* filename);
  virtual bool load_matches(matches& mtches, 
			    const char* filename, 
			    vil1_image* image);
  
protected:
  virtual bool write_header(matches& mtches, 
			    vcl_ofstream& regfile);
  virtual bool load_header(vcl_ifstream& regfile);
  virtual bool write_match(match* m, 
			   vcl_ofstream& regfile);
  virtual bool load_matches_impl(matches& mtches, 
				 vcl_ifstream& regfile,
				 vil1_image* image);
  

protected:
  bool _verbose;
};


#endif
