
// forward to next match between images im1 and im2
bool matches::next_match_between(vil1_image* im1, vil1_image* im2)
{
  while (next_match())
  {
    match m = get_match();
    if (!m.cast_to_pairwise_match())
    {
      vcl_cout << "next_match_between
    region* orig_region = rm.first;
    region* ref_region = rm.second;
    if ( (orig_region->get_image() == im1) &&
	 (ref_region->get_image() == im2) )
      return true;
  }

  return false;
}

// forward to next cluster in im
bool matches::next_cluster_in(vil1_image* im)
{
  while (next_cluster())
  {
    region_cluster_t rc = get_cluster();
    region* reg = rc.front();
    if (reg->get_image() == im)
      return true;
  }
  
  return false;
}

// forward to next match with orig_reg
bool matches::next_match_with(region* orig_reg)
{
  while (next_match())
  {
    region_match_t rm = get_match();
    if (rm.first == orig_reg) 
      return true;
  }

  return false; 
}

// forward to next match with the region with index orig_indx
bool matches::next_match_with(int orig_indx)
{
  while (next_match())
  {
    index_match_t rm = get_match();
    if (rm.first == orig_indx) 
      return true;
  }

  return false; 
}

// forward to next inverse match with orig_reg
bool matches::next_inverse_match_with(region* ref_reg)
{
  while (next_match())
  {
    region_match_t rm = get_match();
    if (rm.second == ref_reg) 
      return true;
  }

  return false;
}

// forward to next inverse match with the region with index orig_indx
bool matches::next_inverse_match_with(int ref_indx)
{
  while (next_match())
  {
    index_match_t rm = get_match();
    if (rm.second == ref_indx) 
      return true;
  }

  return false;
}


// get (first) matching region (if any)
region* matches::get_matching_region_with(region* orig_reg)
{
  reset();
  if (!next_match(orig_reg))
    return NULL;
  region_match_t m = get_match();
    
  return m.second;
}

// get all matching regions (if any)
region_cluster_t matches::get_matching_regions_with(region* orig_reg)
{
  region_cluster_t regs;

  for (reset(); next_match_with(orig_reg); )
  {
    region_match_t m = get_match();
    regs.push_back(m.second);
  }

  return regs;
}

// get all matching regions (if any)
index_cluster_t matches::get_matching_regions_with(int orig_indx)
{
  index_cluster_t regs;

  for (reset(); next_match_with(orig_indx); )
  {
    index_match_t m = get_match();
    regs.push_back(m.second);
  }

  return regs;
}

// get all matching regions (if any)
region_cluster_t matches::get_inverse_matching_regions_with(region* orig_reg)
{
  region_cluster_t regs;

  for (reset(); next_inverse_match_with(orig_reg); )
  {
    region_match_t m = get_match();
    regs.push_back(m.first);
  }

  return regs;
}

// get all matching regions (if any)
index_cluster_t matches::get_inverse_matching_regions_with(int orig_indx)
{
  index_cluster_t regs;

  for (reset(); next_inverse_match_with(orig_indx); )
  {
    index_match_t m = get_match();
    regs.push_back(m.first);
  }

  return regs;
}


// get all matching regions (if any) in image im
region_cluster_t matches::get_matching_regions_with((region* orig_reg, vil1_image* im)
{
  region_cluster_t regs;

  for (reset(); next_match_with(orig_reg); )
  {
    region_match_t m = get_match();
    if (m.second->get_image() == im)
      regs.push_back(m.second);
  }

  return regs;
}

// get all matching regions (if any) in image im
index_cluster_t matches::get_matching_regions_with(int orig_indx, vil1_image* im)
{
  index_cluster_t regs;

  for (reset(); next_match_with(orig_indx); )
  {
    index_match_t m = get_match();
    if (m.second->get_image() == im)
      regs.push_back(m.second);
  }

  return regs;
}

// get all matching regions (if any) in image im
region_cluster_t matches::get_inverse_matching_regions_with(region* ref_reg, vil1_image* im)
{
  region_cluster_t regs;

  for (reset(); next_inverse_match_with(ref_reg); )
  {
    region_match_t m = get_match();
    if (m.first->get_image() == im)
      regs.push_back(m.second);
  }

  return regs;
}

// get all matching regions (if any) in image im
index_cluster_t matches::get_inverse_matching_regions_with(int ref_indx, vil1_image* im)
{
  index_cluster_t regs;

  for (reset(); next_inverse_match_with(ref_indx); )
  {
    index_match_t m = get_match();
    if (m.first->get_image() == im)
      regs.push_back(m.second);
  }

  return regs;
}
