#include <region_matching/pairwise_matches.h>
#include <vcl/vcl_iostream.h>
#include <vcl/vcl_fstream.h>




// Constructors/Destructors--------------------------------------------------
pairwise_matches::pairwise_matches()
{
  _indx = -1;
  _nb_matches = 0;
}

pairwise_matches::~pairwise_matches()
{
  _matchlist.clear();
}
  
// Data Access -----------------------------------------------------------
  
bool pairwise_matches::add(region_match_t mtch)
{
  vcl_cout << "ERROR: pairwise_matches::add(mtch) still has to be implemented" << vcl_endl;
  
  return false;
}

bool pairwise_matches::remove(region_match_t mtch)
{
  vcl_cout << "ERROR: pairwise_matches::remove(mtch) still has to be implemented" << vcl_endl;
  
  return false;
}

bool pairwise_matches::add(index_match_t mtch)
{
  _matchlist.push_back(mtch);
  _nb_matches++;
  
  return true;
}

bool pairwise_matches::remove(index_match_t mtch)
{
  vcl_cout << "ERROR: pairwise_matches::remove(mtch) still has to be implemented" << vcl_endl;
  
  return false;
}

bool pairwise_matches::add(region_cluster_t clstr)
{
  vcl_cout << "ERROR: pairwise_matches::add(clstr) still has to be implemented" << vcl_endl;
  
  return false;
}

bool pairwise_matches::remove(region_cluster_t clstr)
{
  vcl_cout << "ERROR: pairwise_matches::remove(clstr) still has to be implemented" << vcl_endl;
  
  return false;
}

bool pairwise_matches::add(index_cluster_t clstr)
{
  vcl_cout << "ERROR: pairwise_matches::add(clstr) still has to be implemented" << vcl_endl;
  
  return false;
}

bool pairwise_matches::remove(index_cluster_t clstr)
{
  vcl_cout << "ERROR: pairwise_matches::remove(clstr) still has to be implemented" << vcl_endl;
  
  return false;
}
  
// access matches based on index (pairwise matches)
region_match_t pairwise_matches::get_match(int indx)
{
  int orig_indx = _matchlist(indx);
  int ref_indx = _matchlist(indx);
  region* orig_region = _reglist1(orig_indx);
  region* ref_region = _reglist2(ref_indx);
  region_match_t rmtch(orig_region, ref_region);

  return rmtch;
}

index_match_t pairwise_matches::get_match(int indx)
{
  int orig_indx = _matchlist(indx);
  int ref_indx = _matchlist(indx);
  index_match_t imtch(orig_indx, ref_indx);
  
  return imtch;
}

region* pairwise_matches::get_orig_region(int indx)
{
  int orig_indx = _matchlist(indx);
  region* orig_region = _reglist1(orig_indx);
 
  return orig_region;
}

region* pairwise_matches::get_ref_region(int indx)
{
  int ref_indx = _matchlist(indx);
  region* ref_region = _reglist2(ref_indx);
 
  return ref_region;
}

// iterator-like operation to run over all matches / clusters
bool pairwise_matches::reset()
{
  _indx = -1;
}

bool pairwise_matches::next_match()
{
  _indx++;
  return (_indx <= _nb_matches)
}

bool pairwise_matches::next_cluster()
{
  vcl_cout << "ERROR: pairwise_matches::next_cluster() still has to be implemented" << vcl_endl;
}

// get current pairwise match
region_match_t pairwise_matches::get_match()
{
  return get_match(_indx);
}

// get current pairwise match
index_match_t pairwise_matches::get_match()
{
  return get_match(_indx);
}

// get current orig. region
region* pairwise_matches::get_orig_region()
{
  return get_orig_region(_indx);
}

// get current ref. region
region* pairwise_matches::get_ref_region()
{
  return get_ref_region(_indx);
}

// get current cluster
region_cluster pairwise_matches::get_cluster()
{
  return get_cluster(_indx);
}

// get current cluster
index_cluster pairwise_matches::get_cluster()
{
  return get_cluster(_indx);
}

// clusters instead of pairwise matches
region_cluster_t pairwise_matches::get_cluster(int indx)
{
  vcl_cout << "ERROR: pairwise_matches::get_cluster(indx) still has to be implemented" << vcl_endl;
  
  return false;
}

index_cluster_t pairwise_matches::get_cluster(int indx)
{
  vcl_cout << "ERROR: pairwise_matches::get_cluster(indx) still has to be implemented" << vcl_endl;
  
  return false;
}

// get all regions belonging to same cluster as reg (if any)
region_cluster_t pairwise_matches::get_cluster(region* reg)
{
  vcl_cout << "ERROR: pairwise_matches::get_cluster(reg) still has to be implemented" << vcl_endl;
  
  return false;
}

index_cluster_t pairwise_matches::get_cluster(region* reg)
{
  vcl_cout << "ERROR: pairwise_matches::get_cluster(reg) still has to be implemented" << vcl_endl;
  
  return false;
}

 

