#include <region_matching/pairwise_region_match.h>

#include <regions/region.h>


//--- Constructors/Destructors--------------------------------------------------
pairwise_region_match::pairwise_region_match()
  :_orig_region(NULL), _ref_region(NULL)
{

}
  
pairwise_region_match::pairwise_region_match(region* orig_reg, region* ref_reg)
  :_orig_region(orig_reg), _ref_region(ref_reg)
{
  
}

pairwise_region_match::~pairwise_region_match()
{

}


//--- match I/O --------------------------------------------
void pairwise_region_match::print(vcl_ostream& str) const
{
  str << "Pairwise region match " << vcl_endl;
  if (_orig_region) 
    str << _orig_region->get_pt0()->x() << ", " << _orig_region->get_pt0()->y();
  else
    str << "NULL ";
  if (_ref_region)
    str << "  ->  " << _ref_region->get_pt0()->x() << ", " << _ref_region->get_pt0()->y() << vcl_endl;
  else
    str << "  ->  NULL" << vcl_endl;
}

