#include "region_matcher.h"

#include <misc_utility/defines.h>
#include <regions/region.h>
#include <region_matching/reg_match_params.h>

#include <vil1/vil1_image.h>
#include <vil1/vil1_image_as.h>


// -- Constructors / Destructors -----------------------------------

region_matcher::region_matcher(const vil1_image* im1,
			       const vil1_image* im2,
			       regions_list_t& reglist1, 
			       regions_list_t& reglist2,
			       const reg_match_params* p)
{
  _im1 = im1;
  _im2 = im2;

  _reglist1 = reglist1;
  _reglist2 = reglist2;

  if (!p)
    _params = new reg_match_params(); // use default values
  else
    _params = p;

  _mtches = NULL;
}


region_matcher::~region_matcher()
{

}
