#include "bounded_refiner.h"

#include <misc_utility/defines.h>
#include <regions/region.h>

#include <vcl/vcl_cmath.h>
#include <vcl/vcl_vector.h>
#include <vcl/vcl_list.h>

#include <vil1/vil1_image.h>
#include <vil1/vil1_image_as.h>
#include <vil1/vil1_memory_image_of.h>
#include <vil1/vil1_rgb_byte.h>

#include <misc_utility/vic_math.h> // max6
#include <region_utility/misc.h>   // copy_region, project_region



// -- Constructors / Destructors ------------------------------
bounded_refiner::bounded_refiner(similarity_computor* sc,
		 region* r1, region* r2,
		 bool verbose)
  : refiner(sc, r1, r2, verbose)
{
  init_bounds();
}


bounded_refiner::~bounded_refiner() {
}


// Set default bounds
void bounded_refiner::init_bounds() {
  for(int d = 0; d < 6; d++) {
    for(int v = 0; v < 3; v++) {
      _bounds[d][v] = 0.0;
    }
  }
}


void bounded_refiner::set_bounds(float** b) {
  for(int d = 0; d < 6; d++) {
    for(int v = 0; v < 3; v++) {
      _bounds[d][v] = b[d][v];
    }
  }
}



void bounded_refiner::print_pars(float* p) {
  for(int i = 0; i < 6; i++) {
    vcl_cout << p[i] << " ";
  }
}

