#ifndef VIBES_regionfile_h
#define VIBES_regionfile_h

#include <misc_utility/defines.h>
#include <region_utility/region_file.h>
#include <vcl/vcl_sstream.h>
#include <vcl/vcl_iostream.h>
#include <vcl/vcl_fstream.h>
#include <vcl/vcl_vector.h>
#include <vgl/vgl_homg_point_2d.h>

// A class containing some basic functions to read / write
// regions to a file

class region;
class vil1_image;

class VIBES_region_file : public region_file
{
public:
  VIBES_region_file(bool verbose = false);
  virtual ~VIBES_region_file();
  
protected:
  virtual bool write_header(regions_list_t& regs, 
			    vcl_ofstream& regfile);
  virtual bool load_header(vcl_ifstream& regfile);
  virtual bool write_region(region* reg, 
			    vcl_ofstream& regfile);
  virtual bool load_regions_impl(regions_list_t& regs, 
				 vcl_ifstream& regfile,
				 vil1_image* image, 
				 points_list_t* anchors = NULL);
  bool load_region(regions_list_t& regs, 
		   vcl_ifstream& regfile,
		   vil1_image* image, 
		   points_list_t* anchors);

protected:
  int _nb_ell_regions;
};


#endif
