#ifndef Vitto_regionfile_h
#define Vitto_regionfile_h

#include <misc_utility/defines.h>
#include <region_utility/region_file.h>
#include <vcl/vcl_sstream.h>
#include <vcl/vcl_iostream.h>
#include <vcl/vcl_fstream.h>
#include <vcl/vcl_list.h>
#include <vgl/vgl_homg_point_2d.h>

// A class containing some basic functions to read / write
// regions to a file

class region;
class vil1_image;

class Vitto_region_file: public region_file
{
public:
  Vitto_region_file(bool verbose = false);
  ~Vitto_region_file();
  
  bool save_regions(regions_list_t& regs, 
		    const char* filename);

protected:
  virtual bool write_region(region* reg, 
			    vcl_ofstream& regfile);
  bool load_regions_impl(regions_list_t& regs, 
			 vcl_ifstream& regfile, 
			 vil1_image* image, 
			 points_list_t* anchors = NULL);

protected:
  char* _im_ID;
};


#endif
