#ifndef CLUSTERFILTER_H
#define CLUSTERFILTER_H

/* This class is the equivalent of the FilterClustersC.m file */

#include <vil1/vil1_image.h>

#include <misc_utility/defines.h>


class ClusterFilter
{
public:
	ClusterFilter( const vil1_image &image, bool bVerbose=false );
	~ClusterFilter();

	/* Return value = number of surviving regions
	 * sid_/ regs_ filt = (sids of) surviving regions
	 * sid_rmv = sids of removed regions */
	unsigned int filter( const regions_list_t &regions,
	                     int min_main_cluster_size, int min_cluster_size,
	                     vcl_vector<int> *sid_filt=NULL,
	                     regions_list_t *regs_filt=NULL,
	                     vcl_vector<int> *sid_rmv=NULL );

	/* Set verbose output */
	void setVerbose( bool v )
	{ verbose = v; };

private:
	bool verbose;
	color_buffer_t *buf_i;
};


#endif //CLUSTERFILTER_H
