#ifndef _hue_entropy_computor
#define _hue_entropy_computor

//------------------------------------------------------------------------------
// .NAME  hue_entropy_computor - Class for computing the entropy of the
//                               hue histogram of an affinely invariant region
// .LIBRARY 
// .HEADER 
// .INCLUDE 
// .FILE   hue_entropy_computor.h
// .FILE   hue_entropy_computor.cpp
//
// .SECTION Description
//
// .SECTION Author:
//          Vittorio Ferrari
//                ETHZ     
//
// .SECTION Modifications:
//
//
//----------------------------------------------------------------------------

#include <region_utility/saliency_computor.h>

class hue_entropy_computor : public saliency_computor {

 public:
  hue_entropy_computor() {}
  hue_entropy_computor(const color_buffer_t* buf);
  virtual ~hue_entropy_computor();

 public:

protected:
  //--- computations ---------------------------------------------------
  float compute_saliency();   // entropy computation

  // --- utility functions ------------------------------------------
  void compute_hue_histogram();
  void put_in_histogram(vil1_rgb_byte pix);
  void print_histogram();
  float histogram_entropy();

 protected:
  float* _hist;
  int _hue_bins;
  int _grey_bins;
  float _sat_thresh;           // min saturation to be considered a color
  float _value_thresh;         // min value to be considered a color
  int _tot_pixels;             // total amount of pixels in the histogram _hist
};

//----------------------------------------------------------------------------------
//----------------------------------------------------------------------------------


#endif
