#ifndef old_regionfile_h
#define old_regionfile_h

#include <vcl_sstream.h>
#include <vcl_iostream.h>
#include <vcl_fstream.h>
#include <vcl/vcl_list.h>
#include <vgl/vgl_homg_point_2d.h>
#include <region_utility/region_file.h>

// A class containing some basic functions to read / write
// regions to a file

class region;
class vil1_image;

typedef double type_t;
typedef vgl_homg_point_2d<type_t> point_t;

typedef vcl_vector<region*> regions_list_t; 
typedef vcl_vector<point_t*> points_list_t;

class old_region_file: public region_file
{
 public:
  old_region_file(bool verbose = false);
  ~old_region_file();
  
private:
  bool write_header(regions_list_t& regs, 
		    vcl_ofstream& regfile);
  bool write_region(region* reg, 
		    vcl_ofstream& regfile);
  bool load_header(vcl_ifstream& regfile);
  bool load_regions_impl(regions_list_t& regs, 
			 vcl_ifstream& regfile, 
			 vil1_image* image, 
			 points_list_t* anchors = NULL);
};


#endif
