// ----------------------------------------------------------------------
// Utility routines for frequently used region deskewing,
// i.e. the affine transformation into a canonical, rectangular
// coordinate frame.
//
// Author: Tinne Tuytelaars (ESAT)
//
// Modifications: Ported to VXL by Aaron Luttman (ESAT)
//                Templated version by Andreas Turina (ETH)
//
// ----------------------------------------------------------------------


#ifndef _region_deskew_h
#define _region_deskew_h

#include <regions/region.h>

#include <vil1/vil1_rgb_byte.h>
#include <vil1/vil1_memory_image_of.h>



template<class T> vil1_memory_image_of<T>*
deskew_region(const region* region, const vil1_memory_image_of<T>* buf, 
              int sx, int sy, bool mask = true);


template<class T> vil1_memory_image_of<T>*
deskew_region_centered(const region* region, const vil1_memory_image_of<T>* buf, 
                       int sx, int sy, bool mask = true);


template<class T> vil1_memory_image_of<T>*
deskew_region_not_centered(const region* region, const vil1_memory_image_of<T>* buf, 
                           int sx, int sy, bool mask = true);

#endif
