// ----------------------------------------------------------------------
// Utility routines for drawing regions on images,
//
// Author: Vittorio Ferrari (ETHZ)
//
//
// ----------------------------------------------------------------------


#ifndef _region_draw_h
#define _region_draw_h

#include <regions/region.h>
#include <misc_utility/defines.h>                // def of color_buffer_t
#include <vil1/vil1_rgb_byte.h>
#include <vil1/vil1_memory_image_of.h>
#include <regions/uniform_region.h>


void draw_regions(regions_list_t& regions, vil1_rgb<unsigned char>& color, color_buffer_t* buf);
void draw_region(region* reg, vil1_rgb<unsigned char>& col, color_buffer_t* buf);
float overlap_share(region* reg, vil1_rgb<unsigned char>& col, color_buffer_t* buf);
float color_share(region* reg, vil1_rgb<unsigned char>& col, color_buffer_t* buf);
void draw_uniform_region(uniform_region* ur, vil1_rgb<unsigned char>& col, color_buffer_t* buf);

#endif
