#ifndef regionfile_h
#define regionfile_h

#include <vcl/vcl_sstream.h>
#include <vcl/vcl_iostream.h>
#include <vcl/vcl_fstream.h>
#include <vcl/vcl_list.h>
#include <vgl/vgl_homg_point_2d.h>

#include <misc_utility/defines.h>

// A class containing some basic functions to read / write
// regions to a file

class region;
class vil1_image;

class region_file
{
public:
  region_file(bool verbose = false);
  virtual ~region_file();
  
  virtual bool save_regions(regions_list_t& regs, 
			    const char* filename);
  virtual bool load_regions(regions_list_t& regs, 
			    const char* filename, 
			    vil1_image* image, 
			    points_list_t* anchors = NULL);
  
protected:
  virtual bool write_header(regions_list_t& regs, 
			    vcl_ofstream& regfile) { return true;}
  virtual bool load_header(vcl_ifstream& regfile) { return true;}
  virtual bool write_region(region* reg, 
			    vcl_ofstream& regfile) {return true;}
  virtual bool load_regions_impl(regions_list_t& regs, 
				 vcl_ifstream& regfile,
				 vil1_image* image, 
				 points_list_t* anchors = NULL) {return true;}


protected:
  bool _verbose;
};


#endif
