#include "saliency_computor.h"

#include <misc_utility/defines.h>
#include <regions/region.h>

#include <vcl/vcl_cmath.h>
#include <vcl/vcl_vector.h>
#include <vcl/vcl_list.h>

#include <vil1/vil1_image.h>
#include <vil1/vil1_image_as.h>
#include <vil1/vil1_memory_image_of.h>
#include <vil1/vil1_rgb_byte.h>

#include <misc_utility/vic_math.h>               // pdist


// -- Constructors / Destructors ------------------------------
saliency_computor::saliency_computor(const color_buffer_t* buf)
{
  _buf = buf;
  _res = 50;  // default value - can be changed by user

  _adaptive_res = false;
  _min_res = _res;
}



saliency_computor::~saliency_computor() {

}


int saliency_computor::region_resolution(const region* r) {
  point_t* pt0 = r->get_pt0();
  point_t* pt1 = r->get_pt1();
  point_t* pt2 = r->get_pt2();
  float l1 = pdist(pt0,pt1);
  float l2 = pdist(pt0,pt2);

  if(r->get_type() == region::ELL_REGIONTYPE) {
    l1 *= 2.0;
    l2 *= 2.0;
  }

  return (int)( 0.3333 * MAXTWO(l1, l2) );
}


// Assumes _region is non-null and points to an existing region
void saliency_computor::adapt_resolution() {
  _res = MAXTWO(_min_res, region_resolution(_region));
}
