#ifndef ell_region_displayer_h
#define ell_region_displayer_h

//----------------------------------------------------------------------------
// .NAME ell_region_displayer - Class for (gui-dependent) displaying of elliptical regions
// .LIBRARY 
// .HEADER 
// .INCLUDE 
// .FILE   ell_region_displayer.h
// .FILE   ell_region_displayer.C
//
// .SECTION Description
//    The class ell_region_displayer is an class for
//  (gui-dependent) displaying of elliptical regions. 
//
// .SECTION Author:
//          Tinne Tuytelaars, Vittorio Ferrari, Andrew Turina
//          ESAT / KULeuven                BIWI / ETH
//
// .SECTION Modifications:
//     07/01 Restructured and resynchronized code      
//
//----------------------------------------------------------------------------

/*******************************************************************************
*
*	Ported to vxl by Aaron Luttman
*	Notes:	This class does not own any dynamic memory.
*
*******************************************************************************/

#include <regions/region_displayer.h>

class vsol_conic_2d;
class vsol_line_2d;

class ell_region_displayer:public region_displayer
{
friend class ell_region;

protected:
  //--- Constructors/Destructor ---------------------------------
  ell_region_displayer(const ell_region* reg);
  virtual ~ell_region_displayer();

public:
    //--- Utilities  ----------------------------------------------
  virtual void show() const;
  virtual bool update(); // update internal parameters if region has been changed

private:
  vsol_conic_2d* _ellipse; // pointer to ellipse stored in region_
  vsol_line_2d *_l_min, *_l_max;   // min/maj inertia lines
};

#endif // ell_region_displayer_h
