
#ifndef _EllipseDistFunc_
#define _EllipseDistFunc_

/****************************************************************
*
*	Title:	EllipseDistFunc
*	Author:	Aaron Luttman
*	Description:	This is a class derived from vnl_cost_function
*					in vxl/vnl, to be used as an objective function
*					for Amoeba in the ell_region class
*					Tinne Tuytelaars region stuff.  It is for 
*					computing the distance between two ellipses.
*	Note:	This class owns NO dynamic memory.  Thus it does not
*			new or delete the ellipses.
*
****************************************************************/


#include <vnl/vnl_cost_function.h>

class vsol_conic_2d;

class EllipseDistFunc : public vnl_cost_function
{
public:
  EllipseDistFunc(vsol_conic_2d *E1, vsol_conic_2d *E2);
  ~EllipseDistFunc();

  double f(const vnl_vector<double>& x);

private:
  vsol_conic_2d *hE1, *hE2;
  double ha1, ha2, hb1, hb2, hc1, hc2, hd1, hd2, he1, he2, hf1, hf2;
};


#endif // _EllipseDistFunc_
