#ifndef parall_region_displayer_h
#define parall_region_displayer_h

//----------------------------------------------------------------------------
// .NAME parall_regionDisplayer - Class for (gui-dependent) displaying of parall. regions
// .LIBRARY 
// .HEADER 
// .INCLUDE 
// .FILE   parall_regionDisplayer.h
// .FILE   parall_regionDisplayer.C
//
// .SECTION Description
//    The class parall_regionDisplayer is an class for
//  (gui-dependent) displaying of parallelogramshaped regions. 
//
// .SECTION Author:
//          Tinne Tuytelaars, Vittorio Ferrari, Andrew Turina
//          ESAT / KULeuven                BIWI / ETH
//
// .SECTION Modifications:
//     07/01 Restructured and resynchronized code      
//
//----------------------------------------------------------------------------

/************************************************************************************
*
*	Ported to vxl by Aaron Luttman
*	Notes:	This class owns the following memory: l01_, l02_, l13_, l23_
*
************************************************************************************/

#include <regions/region_displayer.h>
#include <vgl/vgl_line_2d.h>

class parall_region_displayer:public region_displayer
{
friend class parall_region;

protected:
  //--- Constructors/Destructor ---------------------------------
  parall_region_displayer(const parall_region* preg);
  virtual ~parall_region_displayer();

public:
    //--- Utilities  ----------------------------------------------
  virtual void show() const;
  virtual bool update(); // update internal parameters if region has been changed

private:
  vgl_line_2d<double> *l01_, *l02_, *l13_, *l23_;
};

#endif // parall_region_displayer_h
