#ifndef region_displayer_h
#define region_displayer_h

//----------------------------------------------------------------------------
// .NAME region_displayer - Basic class for (gui-dependent) displaying of regions
// .LIBRARY 
// .HEADER 
// .INCLUDE 
// .FILE   region_displayer.h
// .FILE   region_displayer.C
//
// .SECTION Description
//    The class region_displayer is an abstract base class for
//  (gui-dependent) displaying of regions. Derived classes include 
//  parall_regionDisplayer and ell_region_displayer.
//
// .SECTION Author:
//          Tinne Tuytelaars, Vittorio Ferrari, Andrew Turina
//          ESAT / KULeuven                BIWI / ETH
//
// .SECTION Modifications:
//     07/01 Restructured and resynchronized code      
//
//----------------------------------------------------------------------------

class region;


class region_displayer
{
friend class region;

protected:
  //--- Constructors/Destructor ---------------------------------
  region_displayer(const region *reg);
  virtual ~region_displayer();

public:
  //--- Utilities  ----------------------------------------------
  virtual void show() const {}
  virtual bool update() { return true;} // update internal parameters if region has been changed

  const region* _region;                // region to be displayed
};




#endif  // region_displayer_h
